# osg::VertexProgram Class Reference

VertexProgram - encapsulates the OpenGL ARB vertex program state. More...

Inheritance diagram for osg::VertexProgram:

[legend]
List of all members.

## Public Types

typedef std::map< GLuint, Vec4 > | LocalParamList

## Public Member Functions

| VertexProgram ()
| VertexProgram (const VertexProgram &vp, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
| META_StateAttribute (osg, VertexProgram, VERTEXPROGRAM)
virtual int | compare (const osg::StateAttribute &sa) const
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
virtual bool | getModeUsage (ModeUsage &usage) const
| Return the modes associated with this StateAttribute.
GLuint & | getVertexProgramID (unsigned int contextID) const
| Get the handle to the vertex program ID for the current context.
void | setVertexProgram (const std::string &program)
| Set the vertex program using C++ style string.
void | setVertexProgram (const char *program)
| Set the vertex program using a C style string.
const std::string & | getVertexProgram () const
| Get the vertex program.
void | setProgramLocalParameter (const GLuint index, const Vec4 &p)
| Set program parameters.
LocalParamList & | getLocalParamList ()
| Get list of Program Parameters.
const LocalParamList & | getLocalParamList () const
| Get const list of Program Parameters.
void | setMatrix (const GLenum mode, const Matrix &matrix)
| Set matrix.
void | dirtyVertexProgramObject ()
| Force a recompile on next apply() of associated OpenGL vertex program objects.
virtual void | apply (State &state) const
| apply the OpenGL state attributes.
virtual void | compileGLObjects (State &state) const
| default to nothing to compile - all state is applied immediately.
virtual void | releaseGLObjects (State *state=0) const
| Release any OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics contexts if State object pointer is NULL.

## Static Public Member Functions

static void | deleteVertexProgramObject (unsigned int contextID, GLuint handle)
| Use deleteVertexProgramObject instead of glDeletePrograms to allow OpenGL Vertex Program objects to cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.
static void | flushDeletedVertexProgramObjects (unsigned int contextID, double currentTime, double &availableTime)
| Flush all the cached vertex programs which need to be deleted in the OpenGL context related to contextID.
static Extensions * | getExtensions (unsigned int contextID, bool createIfNotInitalized)
| Function to call to get the extension of a specified context.
static void | setExtensions (unsigned int contextID, Extensions *extensions)
| The setExtensions method allows users to override the extensions across graphics contexts.

## Protected Types

typedef buffered_value< GLuint > | VertexProgramIDList
typedef std::map< GLenum, Matrix > | MatrixList

## Protected Member Functions

virtual | ~VertexProgram ()

## Protected Attributes

VertexProgramIDList | _vertexProgramIDList
std::string | _vertexProgram
LocalParamList | _programLocalParameters
MatrixList | _matrixList

## Classes

class | Extensions
| Extensions class which encapsulates the querying of extensions and associated function pointers, and provide convenience wrappers to check for the extensions or use the associated functions. More...

## Detailed Description

VertexProgram - encapsulates the OpenGL ARB vertex program state.

## Member Typedef Documentation

typedef std::map<GLuint,Vec4> osg::VertexProgram::LocalParamList

typedef std::map<GLenum,Matrix> osg::VertexProgram::MatrixList `[protected]`

typedef buffered_value<GLuint> osg::VertexProgram::VertexProgramIDList `[protected]`

## Constructor & Destructor Documentation

VertexProgram::VertexProgram | ( |  | ) |

VertexProgram::VertexProgram | ( | const VertexProgram & | vp,
|  | const CopyOp & | copyop = `CopyOp::SHALLOW_COPY`
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

VertexProgram::~VertexProgram | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void VertexProgram::apply | ( | State & | state | ) | const`[virtual]`

| apply the OpenGL state attributes. The global state for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state. Implements osg::StateAttribute.

virtual int osg::VertexProgram::compare | ( | const osg::StateAttribute & | sa | ) | const`[inline, virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

virtual void osg::VertexProgram::compileGLObjects | ( | State & | state | ) | const`[inline, virtual]`

| default to nothing to compile - all state is applied immediately. Reimplemented from osg::StateAttribute.

void VertexProgram::deleteVertexProgramObject | ( | unsigned int | contextID,
|  | GLuint | handle
| ) | `[static]`

| Use deleteVertexProgramObject instead of glDeletePrograms to allow OpenGL Vertex Program objects to cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.

void VertexProgram::dirtyVertexProgramObject | ( |  | ) |

| Force a recompile on next apply() of associated OpenGL vertex program objects.

void VertexProgram::flushDeletedVertexProgramObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime
| ) | `[static]`

| Flush all the cached vertex programs which need to be deleted in the OpenGL context related to contextID.

VertexProgram::Extensions * VertexProgram::getExtensions | ( | unsigned int | contextID,
|  | bool | createIfNotInitalized
| ) | `[static]`

Function to call to get the extension of a specified context.

If the Exentsion object for that context has not yet been created and the 'createIfNotInitalized' flag been set to false then returns NULL. If 'createIfNotInitalized' is true then the Extensions object is automatically created. However, in this case the extension object will only be created with the graphics context associated with ContextID.

const LocalParamList& osg::VertexProgram::getLocalParamList | ( |  | ) | const`[inline]`

| Get const list of Program Parameters.

LocalParamList& osg::VertexProgram::getLocalParamList | ( |  | ) | `[inline]`

| Get list of Program Parameters.

virtual bool osg::VertexProgram::getModeUsage | ( | ModeUsage & | usage | ) | const`[inline, virtual]`

| Return the modes associated with this StateAttribute. Reimplemented from osg::StateAttribute.

const std::string& osg::VertexProgram::getVertexProgram | ( |  | ) | const`[inline]`

| Get the vertex program.

GLuint& osg::VertexProgram::getVertexProgramID | ( | unsigned int | contextID | ) | const`[inline]`

| Get the handle to the vertex program ID for the current context.

osg::VertexProgram::META_StateAttribute | ( | osg | ,
|  | VertexProgram | ,
|  | VERTEXPROGRAM |
| ) |

void VertexProgram::releaseGLObjects | ( | State * | state = `0` | ) | const`[virtual]`

| Release any OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics contexts if State object pointer is NULL. Reimplemented from osg::StateAttribute.

void VertexProgram::setExtensions | ( | unsigned int | contextID,
|  | Extensions * | extensions
| ) | `[static]`

| The setExtensions method allows users to override the extensions across graphics contexts. Typically used when you have different extensions supported across graphics pipes but need to ensure that they all use the same low common denominator extensions.

void osg::VertexProgram::setMatrix | ( | const GLenum | mode,
|  | const Matrix & | matrix
| ) | `[inline]`

| Set matrix.

void osg::VertexProgram::setProgramLocalParameter | ( | const GLuint | index,
|  | const Vec4 & | p
| ) | `[inline]`

| Set program parameters.

void osg::VertexProgram::setVertexProgram | ( | const char * | program | ) | `[inline]`

| Set the vertex program using a C style string.

void osg::VertexProgram::setVertexProgram | ( | const std::string & | program | ) | `[inline]`

| Set the vertex program using C++ style string.

## Member Data Documentation

MatrixList osg::VertexProgram::_matrixList `[protected]`

LocalParamList osg::VertexProgram::_programLocalParameters `[protected]`

std::string osg::VertexProgram::_vertexProgram `[protected]`

VertexProgramIDList osg::VertexProgram::_vertexProgramIDList `[mutable, protected]`

The documentation for this class was generated from the following files:

- VertexProgram
- VertexProgram.cpp